﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AttachDetachExample
{
    class Program
    {
        static void Main(string[] args)
        {
            // Create 
            var employee = new Employee();
            employee.Name = "Employee " + DateTime.Now.ToString();
            var newDetachedEmployee = CreateEmployee(employee);

            // Read
            var detachedReadEmployee = ReadEmployeeById(newDetachedEmployee.EmployeeId);

            // Update
            detachedReadEmployee.Name = "UpdatedEmployee " + DateTime.Now.ToString();
            var updatedDetachedEmployee = UpdateEmployee(detachedReadEmployee);

            // Delete
            DeleteEmployee(updatedDetachedEmployee);


        }

        public static Employee CreateEmployee(Employee employee)
        {
            using (var dbContext = new EntitiesModel1())
            {
                Employee attached = dbContext.AttachCopy(employee);
                dbContext.SaveChanges();
                Employee detached = dbContext.CreateDetachedCopy(attached);

                return detached;
            }
        }

        public static Employee UpdateEmployee(Employee employee)
        {
            using (var dbContext = new EntitiesModel1())
            {
                Employee attached = dbContext.AttachCopy(employee);
                dbContext.SaveChanges();
                Employee detached= dbContext.CreateDetachedCopy(attached);

                return detached;
            }
        }

        public static Employee ReadEmployeeById(int id)
        {
            using (var dbContext = new EntitiesModel1())
            {
                Employee employee = dbContext.Employees.FirstOrDefault(x=>x.EmployeeId == id);
                if (employee != null)
                {
                    Employee detached = dbContext.CreateDetachedCopy(employee);
                    return detached;
                }

                return null;
            }
        }

        public static void DeleteEmployee(Employee employee)
        {
            using (var dbContext = new EntitiesModel1())
            {
                Employee attached = dbContext.AttachCopy(employee);
                dbContext.Delete(attached);
                dbContext.SaveChanges();
            }
        }
    }
}
